package org.objectweb.telosys.common.vo;

import java.io.PrintWriter;
import java.util.List;

import org.objectweb.telosys.common.Telosys;
import org.objectweb.telosys.common.TelosysObject;
import org.objectweb.telosys.rpl.xml.IXmlWrapper;
import org.objectweb.telosys.rpl.xml.IXmlWrapperProvider;

/**
 * 
 * @author Laurent GUERIN
 *  
 */
public class GenericVOListWriter extends TelosysObject
{
    //-----------------------------------------------------------------------------------
    public static void toXml(PrintWriter out, GenericVOList volist, String sListTagName, String sElementTagName)
    {
        if (volist == null)
        {
//            out.println("<!-- toXml(null) -->");
            return;
        }
//        if (!(volist instanceof GenericVOList))
//        {
//            out.println("<!-- ERROR : toXml(.,.) : object argument is not an instance of GenericVOList -->");
//            //error("toXml(.,.) : object argument is not an instance of GenericVOList");
//            return;
//        }
//        GenericVOList genericVOList = (GenericVOList) volist;
        //out.println("<" + _sTagName + ">");
        out.println("<" + sListTagName + ">");
        List list = volist.getList();
        if (list != null)
        {
            IXmlWrapperProvider wrapperProvider = Telosys.getXmlWrapperProvider();
            if ( wrapperProvider != null )
            {
                //--- Get the Wrapper the elements type  
                Class elementClass = volist.getElementType();
                IXmlWrapper elementWrapper = wrapperProvider.getWrapper( elementClass ) ;
                if (elementWrapper != null)
                {
                    Object element = null;
                    int iSize = list.size();
                    //--- For each VO in the list ...
                    for ( int i = 0 ; i < iSize ; i++ )
                    {
                        element = list.get(i);
                        if (element != null)
                        {
                            elementWrapper.toXml(out, element, sElementTagName);
                        }
                        else
                        {
                            out.println("<!-- Element [" + i + "] of the list is NULL -->");
                        }
                    }
                }
                else
                {
                    out.println("<!-- ERROR : no XML wrapper for class " + elementClass + " -->");
                    //error("toXml() : the bean XML wrapper is null ");
                }
            }
            else
            {
                out.println("<!-- ERROR : cannot get XmlWrapperProvider -->");
            }
        }
        else
        {
            out.println("<!-- ERROR : List in GenericVOList is NULL -->");
        }
        //out.println("</" + _sTagName + ">");
        out.println("</" + sListTagName + ">");
    }
}