package org.objectweb.telosys.rpl;

import java.util.Properties;

import org.objectweb.telosys.common.Telosys;

/**
 * @author Laurent GUERIN
 *  
 */
public final class TelosysRPL
{
    private final static String XML_WRAPPER_PACKAGE = "XmlWrapperPackage";

    private final static String XML_WRAPPER_SUFFIX  = "XmlWrapperSuffix";

    private final static String CLASS_NAME          = "TelosysRPL";

    //--- Default wrapper package
    private static String       $sXmlWrapperPackage = null;

    //--- Default suffix (for the Wrapper class name)
    private static String       $sXmlWrapperSuffix  = null;

    //-----------------------------------------------------------------------------
    private static boolean initWithProperties(Properties prop)
    {
        boolean bRet = true;
        String s = null;

        //--- XML wrapper package
        s = prop.getProperty(XML_WRAPPER_PACKAGE);
        if (s == null)
        {
            Telosys.error(CLASS_NAME + ".init() : property '" + XML_WRAPPER_PACKAGE + "' not found ");
            bRet = false;
        }
        else
        {
            $sXmlWrapperPackage = s.trim();
            Telosys.info(CLASS_NAME + ".init() : property '" + XML_WRAPPER_PACKAGE + "' = '" + $sXmlWrapperPackage + "'");
        }

        //--- XML wrapper suffix
        s = prop.getProperty(XML_WRAPPER_SUFFIX);
        if (s == null)
        {
            Telosys.error(CLASS_NAME + ".init() : property '" + XML_WRAPPER_SUFFIX + "'  not found ");
            bRet = false;
        }
        else
        {
            $sXmlWrapperSuffix = s.trim();
            Telosys.info(CLASS_NAME + ".init() : property '" + XML_WRAPPER_SUFFIX + "' = '" + $sXmlWrapperSuffix + "'");
        }

        return bRet;
    }

    //-----------------------------------------------------------------------------
    // PUBLIC METHODS
    //-----------------------------------------------------------------------------
    /**
     * R.P.L. initialization
     * 
     * @return
     */
    public static boolean init()
    {
        Telosys.info("TelosysRPL : INIT without properties ...");
        /***********************************************************************************************************************************************************************************************
         * TelosysFactory factory = Telosys.getFactory(); if (factory != null) { IXmlWrapperProvider wrapperProvider = factory.getXmlWrapperProvider(); if ( wrapperProvider != null ) {
         * Telosys.info("TelosysRPL : INIT OK" ); return true ; } } Telosys.info("TelosysRPL : INIT ERROR ( Cannot get Wrapper Provider )!" ); return false ;
         **********************************************************************************************************************************************************************************************/
        //--- Get the Telosys properties ...
        Properties prop = Telosys.getProperties();
        if (prop != null)
        {
            return initWithProperties(prop);
        }
        else
        {
            Telosys.error(CLASS_NAME +".init() : cannot get Telosys properties !");
            return false;
        }
    }

    //-----------------------------------------------------------------------------
    // PUBLIC GETTERS
    //-----------------------------------------------------------------------------
    public static String getXmlWrapperPackage()
    {
        return $sXmlWrapperPackage;
    }

    public static String getXmlWrapperSuffix()
    {
        return $sXmlWrapperSuffix;
    }

}