package org.objectweb.telosys.uil.taglib;

import javax.servlet.jsp.PageContext;

import org.objectweb.telosys.common.TelosysRuntimeException;
import org.objectweb.telosys.util.VarSetter;


/**
 * @author GUERIN
 *  
 */
public class TagVarSetter extends VarSetter
{
    PageContext _pageContext = null ;    
    
    /**
     * @param pageContext
     */
    public TagVarSetter(PageContext pageContext)
    {
        super();
        if ( pageContext != null )
        {
            _pageContext = pageContext;            
        }
        else
        {
            throw new TelosysRuntimeException("TagVarSetter constructor : pageContext is null!");
        }
    }
    
    /* (non-Javadoc)
     * @see org.objectweb.telosys.util.VarSetter#getVarValue(java.lang.String)
     */
    protected String getVarValue(String s)
    {
        if ( s != null )
        {
            String s2 = s.trim();
            if ( s2.equalsIgnoreCase("#count") )
            {
                //--- Predefined variable "ITERATION COUNT"
                int iCount = Page.getIterationCount(_pageContext);
                return ""+iCount;
            }
            else if ( s2.equalsIgnoreCase("#index") )
            {
                //--- Predefined variable "ITERATION INDEX"
                int iIndex = Page.getIterationIndex(_pageContext);
                return ""+iIndex;                
            }
            else
            {                
	            char c = s.charAt(0);
	            if ( c >= '0' && c <= '9' ) // Numeric => Column 
	            {
	                //--- Get DataRow column value   
	                Object oValue = CurrentBean.getColumn(_pageContext, s2);
	                return ( oValue != null ? oValue.toString() : "{"+s2+"?}" );
	            }
	            else
	            {
	                //--- Get BEAN ATTRIBUTE value   
	                Object oValue = Finder.findAttributeValue(_pageContext, s2);
	                return ( oValue != null ? oValue.toString() : "{"+s2+"?}" );
	            }            
            }
        }
        return "{null!}";
    }
    
}