package org.objectweb.telosys.uil.taglib.util;

import org.objectweb.telosys.uil.taglib.CommonTagSupport;
import org.objectweb.telosys.uil.taglib.Page;

/**
 * @author Laurent GUERIN
 *  
 */
public class Loop extends CommonTagSupport // TagSupport
{
    //----------------------------------------------------------------
    // Private variables
    //----------------------------------------------------------------
    private int    _iCount = 0;

    private int    _iIndex = 0;

    private int    _iFrom  = 0;

    private int    _iTo    = 0;

    private int    _iStep  = 0;

    //----------------------------------------------------------------
    // Tag attributes
    //----------------------------------------------------------------
    private String _sFrom  = null;

    private String _sTo    = null;

    private String _sStep  = "1";

    public void setFrom(String v)
    {
        this._sFrom = v;
    }

    public void setTo(String v)
    {
        this._sTo = v;
    }

    public void setStep(String v)
    {
        this._sStep = v;
    }

    //----------------------------------------------------------------
    /**
     * @return true if the loop must continue
     */
    private boolean continueLoop()
    {
        if (_iFrom < _iTo) //--- ie : from 10 to 18
        {
            if (_iIndex <= _iTo && _iStep > 0 )
            {
                _iCount++; // 1 to N
                return true;
            }
            else
            {
                return false;
            }
        }
        if (_iFrom > _iTo) //--- ie : from 24 to 6
        {
            if (_iIndex >= _iTo && _iStep < 0 )
            {
                _iCount++; // 1 to N
                return true;
            }
            else
            {
                return false;
            }
        }
        if (_iFrom == _iTo) //--- ie : from 6 to 6
        {
            if (_iCount == 0)
            {
                _iCount++; // 1 to N
                _iIndex = _iFrom;
                return true;
            }
            else
            {
                return false;
            }
        }
        return false;
    }

    //----------------------------------------------------------------
    private boolean init()
    {
        String s = "";
        try
        {
            s = "from";
            _iFrom = Integer.parseInt(_sFrom);
            
            s = "to";
            _iTo = Integer.parseInt(_sTo);
            
            _iStep = 1 ;
            s = "step";
            if ( _sStep != null )
            {
                if ( _sStep.trim().length() > 0 )
                {
                    _iStep = Integer.parseInt(_sStep);                    
                }
            }
        } catch (NumberFormatException ex)
        {
            tagLibError("<!-- LOOP ERROR : Cannot parse attribute '" + s + "' -->");
            return false;
        }
        return true;
    }

    //----------------------------------------------------------------
    public int doStartTag()
    {
        if (init())
        {
            _iCount = 0;
            _iIndex = _iFrom; //--- Initial value
            if (continueLoop())
            {
                Page.setIterationCount(pageContext, _iCount);
                Page.setIterationIndex(pageContext, _iIndex);
                
                return EVAL_BODY_INCLUDE;
            }
        }
        return SKIP_BODY;
    }

    //----------------------------------------------------------------
    public int doAfterBody()
    {
        //--- Next step in the loop
        _iIndex = _iIndex + _iStep;
        if (continueLoop())
        {
            Page.setIterationCount(pageContext, _iCount);
            Page.setIterationIndex(pageContext, _iIndex);

            return EVAL_BODY_AGAIN;
        }
        return SKIP_BODY;
    }
    //----------------------------------------------------------------
}