package org.objectweb.telosys.uil.taglib.widget;

import org.objectweb.telosys.uil.taglib.widget.html.FileUploadHTML;

/**
 * @author Laurent GUERIN 
 *  
 */

public class FileUpload extends GenericTag
{
    private static final String  TAG_NAME = "upload";

    //----------------------------------------------------------------
    // TAG generators ( thread safe => static )
    //----------------------------------------------------------------
    private final static IWidget $htmlGen = new FileUploadHTML();

    private final static IWidget $xulGen  = null;

    //----------------------------------------------------------------
    // TAG attributes
    //----------------------------------------------------------------

    private String               _sMaxSize    		= null;

    private String               _sDestDir    		= null;

    private String               _sContextId   		= null;
    
    private String               _sContextAttribute = null;
    
    private String               _sSessionKey  		= null;
    
    private String               _sCallBack   		= null;

    /**
     * Constructor
     */
    public FileUpload()
    {
        super(TAG_NAME, $htmlGen, $xulGen);
    }

    //----------------------------------------------------------------
    public void setMaxsize(String v)
    {
        _sMaxSize = v;
    }

    public String getMaxsize()
    {
        return _sMaxSize;
    }

    //----------------------------------------------------------------
    public void setDestdir(String v)
    {
        _sDestDir = v;
    }

    public String getDestdir()
    {
        return _sDestDir;
    }

    //----------------------------------------------------------------
    public void setContextid(String v)
    {
        _sContextId = v;
    }

    public String getContextid()
    {
        return _sContextId;
    }
    
    //  ----------------------------------------------------------------
    public void setContextattribute(String v)
    {
        _sContextAttribute = v;
    }

    public String getContextattribute()
    {
        return _sContextAttribute;
    }
    
    //  ----------------------------------------------------------------
    public void setSessionkey(String v)
    {
        _sSessionKey = v;
    }
    
    public String getSessionkey()
    {
        return _sSessionKey;
    }
    
    //  ----------------------------------------------------------------
    public void setCallback(String v)
    {
        _sCallBack = v;
    }

    public String getCallback()
    {
        return _sCallBack;
    }

    

    //----------------------------------------------------------------
    public int doStartTag()
    {
        startTag();
        return (SKIP_BODY);
    }
    
}