package org.objectweb.telosys.uil.taglib.widget;

import javax.servlet.jsp.tagext.Tag;

import org.objectweb.telosys.uil.taglib.widget.html.ListCellHTML;

/**
 * @author Laurent GUERIN
 *  
 */
public class ListCell extends GenericTag
{
    protected static final String TAG_NAME = "cell";

    //----------------------------------------------------------------
    // TAG generators ( thread safe => static )
    //----------------------------------------------------------------
    private final static IWidget  $htmlGen = new ListCellHTML();

    private final static IWidget  $xulGen  = null;

    //----------------------------------------------------------------
    // TAG attributes
    //----------------------------------------------------------------
//    private String                _sTxt    = "xxx";
//
//    private String                _sImgSrc = null;            // Image ( with full source path )
//
//    private String                _sImg    = null;            // Image ( in context standard path )
//
//    private String                _sImgPos = "left";

    private String                _sAlign  = "middle";

//    private String                _sSpacer = "4";

    /**
     * Constructor
     */
    public ListCell()
    {
        super(TAG_NAME, $htmlGen, $xulGen);
    }

    //----------------------------------------------------------------
//    public void setTxt(String v)
//    {
//        _sTxt = v;
//    }
//
//    public String getTxt()
//    {
//        return _sTxt;
//    }
//
    //----------------------------------------------------------------
//    public void setImgsrc(String v)
//    {
//        _sImgSrc = v;
//    }
//
//    //----------------------------------------------------------------
//    public void setImg(String v)
//    {
//        _sImg = v;
//    }
//
//    public String getFullImageSrc()
//    {
//        if (notVoid(_sImgSrc))
//        {
//            return _sImgSrc.trim();
//        }
//        else if (notVoid(_sImg))
//        {
//            return super.getFullImageSrc(_sImg);
//        }
//        else
//        {
//            return null;
//        }
//    }
//
//    //----------------------------------------------------------------
//    public void setImgpos(String v)
//    {
//        _sImgPos = v;
//    }
//
//    public String getImgpos()
//    {
//        return _sImgPos;
//    }
//
//    //----------------------------------------------------------------
//    public void setSpacer(String v)
//    {
//        _sSpacer = v;
//    }
//
//    public void setSpacer(int v)
//    {
//        _sSpacer = "" + v;
//    }
//
//    public String getSpacer()
//    {
//        return _sSpacer;
//    }
//
    //----------------------------------------------------------------
    public List getParentList()
    {
        Tag parentTag = getParent();
        if (parentTag != null)
        {
            if ( parentTag instanceof ListRow )
            {
                parentTag = parentTag.getParent();
                if ( parentTag instanceof ListHead )
                {
                    parentTag = parentTag.getParent();
                    if ( parentTag instanceof List )
                    {
                        return (List) parentTag;
                    }
                }
            }
        }
        return null;
    }
    
    //----------------------------------------------------------------
//    public String getWidth()
//    {
//        String sWidth = super.getWidth();
//        if ( sWidth != null )
//        {
//            //--- Witdh attribute set for the current tag => use it 
//            return sWidth;            
//        }
//        else
//        {
//            List list = getParentList();
//            return list.getCellWidth();
//        }
//    }
    
    //----------------------------------------------------------------
    public void setAlign(String v)
    {
        _sAlign = v;
    }
    public String getAlign()
    {
        if ( _sAlign != null )
        {
            return _sAlign.trim() ;            
        }
        return _sAlign ;
    }

    //----------------------------------------------------------------
    //----------------------------------------------------------------
    /*
     * (non-Javadoc)
     * 
     * @see javax.servlet.jsp.tagext.Tag#doStartTag()
     */
    public int doStartTag()
    {
//        applyDefaults();
//        Page.initTabIndex(pageContext);
        startTag();
        return (EVAL_BODY_INCLUDE);
    }

    //----------------------------------------------------------------
    /*
     * (non-Javadoc)
     * 
     * @see javax.servlet.jsp.tagext.Tag#doEndTag()
     */
    public int doEndTag()
    {
        endTag();
//        reset();
        return (EVAL_PAGE); //  EVAL_PAGE = continue , SKIP_PAGE = abort the processing
    }
    
    
    
}